--- old/usr/src/lib/libm/common/m9x/fmin.c	2014-05-04 03:06:39.230656496 +0200
+++ new/usr/src/lib/libm/common/m9x/fmin.c	2014-05-04 03:06:39.259578599 +0200
@@ -41,6 +41,8 @@
 
 #include "libm.h"	/* for islessequal macro */
 
+#include "fenv_inlines.h"
+#include <stdio.h>
 #include <sys/isa_defs.h>
 
 double
@@ -50,7 +52,7 @@
 		double d;
 	} xx, yy;
 	unsigned s;
-
+	
 	/* if y is nan, replace it by x */
 	if (y != y)
 		y = x;
@@ -59,17 +61,12 @@
 	if (x != x)
 		x = y;
 
-	/* if x is greater than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x != x || x > y)
-#else
-	if (!islessequal(x, y))
-#endif
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !islessequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; set the
-	 * sign of the result if either x or y has its sign set
+	 * set the sign of the result if either x or y has its sign set
 	 */
 	xx.d = x;
 	yy.d = y;
